Package: LBE
Type: Package
Title: Estimation of the false discovery rate
Version: 1.80.0
Date: 2024-05-08
Author: Cyril Dalmasso
Maintainer: Cyril Dalmasso <cyril.dalmasso@univ-evry.fr>
Description: LBE is an efficient procedure for estimating the
        proportion of true null hypotheses, the false discovery rate
        (and so the q-values) in the framework of estimating procedures
        based on the marginal distribution of the p-values without
        assumption for the alternative hypothesis.
Depends: stats
Imports: graphics, stats, utils
License: GPL-2
Suggests: qvalue
biocViews: MultipleComparison
git_url: https://git.bioconductor.org/packages/LBE
git_branch: RELEASE_3_23
git_last_commit: 486aee3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:52:50 UTC; biocbuild

`LBEsummary` <-
function (LBEobj, cuts = c(1e-04, 0.001, 0.01, 0.025, 0.05, 0.1,1), digits = getOption("digits"), ...){
    cat("\nCall:\n", deparse(LBEobj$call), "\n\n", sep = "")
    cat("pi0:", format(LBEobj$pi0, digits = digits), "\n", sep = "\t")
    cat(paste("Confidence Interval (level=",LBEobj$ci.level,"): [",format(LBEobj$pi0.ci[1], digits = digits),",",format(LBEobj$pi0.ci[2],digits=digits),"]",sep=""),"\n")
    cat("\n")
    cat("Cumulative number of significant calls:\n")
    cat("\n")
    counts<-sapply(cuts, function(x) c("p-value" = sum(LBEobj$pvalues<x), "q-value" = sum(LBEobj$qvalues < x)))
    colnames(counts)<-paste("<", cuts, sep = "")
    print(counts)
    cat("\n")
    invisible(LBEobj)
}

`LBEa` <-
function(m,l=0.05,fig=TRUE,a.rng=NA){
  asearch <- function(a) {
    abs(sqrt(1/(gamma(a + 1))^2 * ((gamma(2 * a + 1) - (gamma(a + 1))^2)/m)) - l)
  }
  aopt <- max(1, optimize(asearch, c(0.3, 25))$minimum)
  if (fig){
    par(mfrow=c(1,1))
    if (is.na(a.rng[1])){
      asearch2 <- function(a) {
        abs(sqrt(1/(gamma(a + 1))^2 * ((gamma(2 * a + 1) - (gamma(a + 1))^2)/m)) - 0.5)
      }
      a.rng=c(1,max(1, optimize(asearch2, c(0.3, 30))$minimum))
    }
    a2<-seq(a.rng[1],a.rng[2],0.01)
    sd <- sqrt(1/(gamma(a2 + 1))^2 * ((gamma(2 * a2 + 1) - (gamma(a2 + 1))^2)/m))
    plot(a2,sd,type="l",lwd=3,col=4,ylab="standard deviation",xlab="a")
    abline(h=l,col="orange",lwd=3)
    abline(v=aopt,lty=2,lwd=2)
    legend(aopt,l,paste("a =",round(aopt,5)),bty="n",xjust=0,yjust=1,cex=1,col="white")
  }
  return(aopt)
}

`LBE` <-
function (pval, a = NA, l = 0.05, ci.level = 0.95, qvalues = TRUE,
    plot.type = "main", FDR.level = 0.05, n.significant = NA)
{
    if (min(pval) < 0 | max(pval) > 1) {
        print("ERROR: p-values not in valid range.")
        return(0)
    }
    else {
        m <- length(pval)
        FDR <- NA
        if (is.na(a) == FALSE & a < 1) {
            a <- NA
            sdbound <- sqrt(1/(3 * m))
            pi0 <- min(1, mean(pval) * 2)
            icpi0 <- c(0, pi0 - qnorm((1 - ci.level), 0, sdbound))
        }
        else {
            if (is.na(a)) {
                a <- LBEa(m,l,fig=FALSE)
            }
            sdbound <- sqrt((1/(gamma(a + 1))^2) * ((gamma(2 *
                a + 1) - (gamma(a + 1))^2)/m))
            pi0 <- min(1, mean((-log(1 - pval))^a)/gamma(a +
                1))
            icpi0 <- c(0, min(1, pi0 - qnorm((1 - ci.level),
                0, sdbound)))
        }
        mat <- NA
        if (qvalues == TRUE) {
            qval <- rep(NA, m)
            sort.pval <- sort(pval)
            order.pval <- order(pval)
            rank.pval <- rank(pval)
            qval[m] <- (pi0 * m * sort.pval[m])/m
            for (i in 1:(m - 1)) {
                qval[m - i] <- min((pi0 * m * sort.pval[m - i])/(m -
                  i), qval[m - i + 1])
            }
            mat <- cbind(rank.pval, qval, sort.pval)
           
            if (is.na(n.significant) == FALSE) {
                FDR.level <- mat[n.significant, 2]
                FDR <- FDR.level
            }
            else {
                n.significant <- length(mat[mat[, 2] <= FDR.level,
                  2])
                FDR <- max(mat[mat[, 2] <= FDR.level, 2],0)
            }
        }
    
        if (sdbound>0.5){
            print(paste("WARNING: l = ",sdbound,". A smaller value is recommended for a (or l).",sep=""))
        }
        
        if (qvalues == TRUE) {
          significant<-(qval[rank.pval] <= FDR.level)
          r <- list(call = match.call(), FDR = FDR, pi0 = pi0, pi0.ci = icpi0, ci.level = ci.level, a = a, l = sdbound, qvalues = qval[rank.pval], pvalues = pval, significant = significant, n.significant = length(significant[significant==TRUE]))
          class(r) <- "LBE"
          if(plot.type!="none"&qvalues==TRUE){
            LBEplot(r,plot.type=plot.type)
          }
          invisible(r)
        }
        else {
          r <- list(call = match.call(), FDR = NA, pi0 = pi0, pi0.ci = icpi0, ci.level = ci.level, a = a, l = sdbound, qvalues = NA, pvalues = pvalues, significant = NA, n.significant = NA)
          class(r) <- "LBE"
          invisible(r)
        }
    }
}

`LBEwrite` <-
function (LBEobj, filename = "LBE-results.txt"){
    cat(c("pi0:", LBEobj$pi0, "\n\n"), file = filename, append = FALSE)
    cat(c("ic.pi0:", LBEobj$ci.pi0, "\n\n"), file = filename, append = FALSE)   
    cat(c("FDR:", LBEobj$FDR, "\n\n"), file = filename, append = TRUE)
    cat(c("p-value q-value significant", "\n"), file = filename, append = TRUE)
    write(t(cbind(LBEobj$pval, LBEobj$qval, LBEobj$significant)), file = filename, ncolumns=3, sep="\t", append = TRUE)
}

`LBEplot` <-
function (LBEobj, rng = c(0, 0.1), plot.type = c("multiple","main"),legend=TRUE){
    if (class(LBEobj)=="LBE" ){    
      if (is.na(LBEobj$qvalues[1])) {
        print("ERROR: Estimated q-values not found. Apply the function LBE with the option: qvalues=TRUE.")
      }     
      else {
        q2 <- LBEobj$qval[order(LBEobj$pval)]
        if (min(q2) > rng[2]) {
            rng <- c(min(q2), quantile(q2, 0.1))
        }
        p2 <- LBEobj$pval[order(LBEobj$pval)]
        m <- length(q2)
        if (plot.type[1] == "main"){
          nf <- layout(cbind(rep(0, 12), matrix(c(rep(1,81), rep(2, 27)), ncol = 9, byrow = TRUE),rep(0, 12)), respect = FALSE)
          plot(p2, q2, xlab = "p-values", ylab = "q-values",xlim = c(0, 1), ylim = c(0, 1), col = "blue",pch = 16)
          par(new = TRUE)
          plot(p2[q2 <= LBEobj$FDR], q2[q2 <= LBEobj$FDR], xlab = "p-values", ylab = "q-values",xlim = c(0, 1), ylim = c(0, 1), col = "orange", pch = 16)
          if (legend == TRUE) {
            n.select<-length(LBEobj$significant[LBEobj$significant==TRUE])
            legend(1, 0, c(paste("FDR =", round(LBEobj$FDR, digits = 5)), paste(m - n.select, "non rejected null hypotheses"), paste(n.select, "rejected null hypotheses")), pch = rep(16, 3), col = c("white", "blue", "orange"), xjust = 1, yjust = 0, cex = 1.5, bty = "n")
          }
          hist(p2, xlim = c(0, 1), nclass = 100, ann = FALSE, xlab = "p-values", xaxt = "n", yaxt = "n", main = "")
        }
        if (plot.type[1] == "multiple"){
          par(mfrow=c(2,2))
          hist(p2,xlab = "p-value", ylab = "frequency",main="",col="blue")
          plot(p2[q2 >= rng[1] & q2 <= rng[2]], q2[q2 >= rng[1] & q2 <=
           rng[2]], type = "l", xlab = "p-value", ylab = "q-value",col="blue",lwd=2)
          plot(q2[q2 >= rng[1] & q2 <= rng[2]], (1 + sum(q2 < rng[1])):sum(q2 <=
            rng[2]), type = "l", xlab = "q-value cut-off", ylab = "significant tests",col="blue",lwd=2)
          plot((1 + sum(q2 < rng[1])):sum(q2 <= rng[2]), q2[q2 >= rng[1] &
            q2 <= rng[2]] * (1 + sum(q2 < rng[1])):sum(q2 <= rng[2]),
            type = "l", xlab = "significant tests", ylab = "expected false positives",col="blue",lwd=2)
        } 
      }
    }
    else {
            print("ERROR: An LBE object is required as input.")
    }            
}

%\VignetteIndexEntry{LBE Vignette}
%\VignetteDepends{LBE}
%\VignetteKeywords{multiple comparisons, false discovery rate, proportion of true null hypotheses}
%\VignettePackage{LBE}

\documentclass[11pt]{article}

\usepackage{times}
\usepackage{hyperref}
\usepackage{times}
\usepackage{comment}

\textwidth=6.2in
\textheight=8.5in
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newlength{\smallfigwidth}
\setlength{\smallfigwidth}{6cm}

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textsf{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}


\title{How to use the LBE package}
\author{C. Dalmasso}

\begin{document}

\maketitle

\section{Introduction}


In the context of genome-wide studies for which a large number of statistical tests are simultaneously performed, the False Discovery Rate
(FDR) which is defined as the expected proportion of false discoveries \cite{Benjamini} is one of the most used criterion for taking into account the multiple testing problem.

In the framework of estimating procedures based on the marginal distribution of the p-values without assumption on the conditional distribution related to the alternative hypothesis, estimators of the FDR rely on the formula introduced by Storey \cite{Storey1}: 

\begin{equation}
FDR(\Gamma )=\frac{\pi _{0}\Pr (P\in G|H=0)}{\Pr (P\in G)}  \label{Storey}
\end{equation}

where $H$ is the variable such that $H=0$ if the null hypothesis $H_{0}$ is true, $H=1$ if the alternative hypothesis $H_{1}$ is true, $\pi _{0}=\Pr(H=0)$ is the probability of not being modified and $P$ is the random variable corresponding to the p-values. 

\bigskip

This document provides a tutorial for using the \Rfunction{LBE} package that contains functions for estimating the proportion of true null hypotheses $\pi _{0}$ and the $FDR$ (or the q-values that are defined for each p-value by q-value$(p_{i})=FDR([0,p_{i}])$). We describe here the implemented functions and illustrate their use with the real dataset from Golub et al. \cite{Golub}. In the last section, the LBE function is compared with the \Rfunction{qvalue} function from the \Rfunction{qvalue} package.


\section{The leukemia data set from Golub et al. (1999)}


The aim of the study of Golub et al. \cite{Golub} was to identify differentially expressed genes between acute myeloid leukemia (AML) and
acute lymphoblastic leukemia (ALL). The samples were assayed using Affymetrix Hgu6800 chips and the data on the expression of 7129 genes are
available in the Bioconductor package \Rfunction{golubEsets}. 

The dataset \Rfunction{golub.pval} provided  with the LBE package contains the p-values obtained from a two-sample t-test analysis. The variance-stabilizing method included in the \Rfunction{vsn} package was applied for normalizing the data.

\bigskip 

<<>>=
library(LBE)
data(golub.pval)
@


\section{Implemented functions}

\subsection{\Rfunction{LBE}}

Under the null hypothesis, the p-values are supposed to be uniformly distributed on [0,1] so that $\Pr (P\in \lbrack 0,\gamma ]|H=0)=\gamma $. The FDR estimation is then obtained from the relation (\ref{Storey}) by the separate estimation of $\Pr (P\in \lbrack 0,\gamma ])$ and $\pi _{0}$, the proportion of true null hypotheses. While $\Pr (P\in \lbrack 0,\gamma ])$ can easily be estimated by the empirical cumulative distribution, if no distributional assumption is made for the marginal distribution of the p-values, only an upper bound estimate can be obtained for $\pi _{0}$.

\bigskip 

Let $m$ be the total number of p-values. From a classical two-components mixture model for the distribution of the p-values, we have
introduced \cite{Dalmasso} a conservatively biased estimator of $\pi _{0}$: 

\begin{equation}
\widehat{\pi }_{0}=2\frac{1}{m}\sum\limits_{i=1}^{m}P_{i}  \label{initest}
\end{equation}

From this estimator of $\pi _{0}$, we have demonstrated that under suitable conditions for a function $\varphi $, transformed p-values lead to a less biased estimator of $\pi _{0}$ (see the theorem 1 in \cite{Dalmasso}). In this context, we have considered the functions $\varphi _{a}(P)=-\ln(1-x)^{a},~a\in [1,+\inf[$, and we have demonstrated that these functions lead to a family of estimators for which the bias for $\pi _{0}$ is decreasing with $a$. The obtained results can easily be extended to real values of $a$ leading to the following family of estimators: 

\begin{equation}
\hat{\pi}_{0(a)}=\frac{\frac{1}{m}\sum_{i=1}^{m}[-\ln (1-p_{i})]^{a}}{\Gamma
(a+1)},~a\in \lbrack 1,+\inf [.  \label{family}
\end{equation}

For this family of estimators,an upper bound of the asymptotic variance can be obtained for independent p-values: $\frac{1}{m}\times \left( 
\frac{\Gamma (2a+1)}{\Gamma (a+1)^{2}}-1\right) $ leading to a confidence interval for $\pi _{0}$. As there is a balance between bias (decreasing as $a$ increase) and variance (increasing as $a$ increase), for a specified number $m$ of tested hypotheses, we have proposed to choose $a$ as the greatest value such that the upper bound of the standard deviation is less than a threshold $l$ for the variance's upper bound. Other rules may obviously be considered and the \Rfunction{LBE} function allows to set $a$ independently from the variance upper bound.

\bigskip

The \Rfunction{LBE} function only requires a vector of p-values as input. We first create the object \Rfunction{LBE.res} by applying the \Rfunction{LBE} function with default arguments. A plot of the q-values versus the p-values is displayed together with the histogram of the p-values and informative numerical values in the legend such as the FDR and the number of rejected null hypotheses. Among the saved results \Rfunction{LBE.res}, we display the estimate of $\pi _{0}$, its confidence interval and the (default) level for the confidence interval.
Then, we apply the \Rfunction{LBE} function once again by changing the level for the confidence interval and we display the new confidence interval for $\pi _{0}$. The argument plot.type is set to "none" so that the plot is not displayed.



\begin{center}
<<fig=true, width = 6, height = 6>>=
LBE.res <- LBE(golub.pval)
@
\end{center}
\bigskip

<<>>=
#LBE.res <- LBE(golub.pval)
names(LBE.res)
LBE.res$pi0; LBE.res$pi0.ci; LBE.res$ci.level
LBE.res2 <- LBE(golub.pval, ci.level=0.8,plot.type="none")
LBE.res2$pi0.ci; LBE.res2$ci.level
@

\bigskip

If the argument \Rfunction{qvalues} is set to \Rfunction{FALSE}, only $\pi _{0}$ is estimated. Otherwise (default value), the q-values (which are defined for each gene by q-value$(p_{i})=FDR([0,p_{i}])$ are estimated and the \Rfunction{LBE} function returns either the number of significant genes when controlling the FDR at a specific level (the default value for the argument \Rfunction{FDR.level} is 0.05), either the estimated FDR for a specific number of significant genes.

First, we apply the \Rfunction{LBE} function by changing the level at which control the FDR, then we estimate the FDR when 300 genes are declared significant. It is worth noting that the estimated q-values remain unchanged.

\bigskip

<<>>=
LBE.res3 <- LBE(golub.pval, FDR.level=0.1,plot.type="none")
LBE.res3$qvalues[1:10]
LBE.res3$n.significant
@

\begin{center}
<<fig=true, width = 6, height = 6>>=
LBE.res4 <- LBE(golub.pval,FDR.level=NA,n.significant=300)
@
\end{center}
\bigskip

<<>>=
LBE.res4$qvalues[1:10]
@

\bigskip

Using the proposed rule for choosing a particular estimator in the family (\ref{family}), the parameter \Rfunction{a} is set according to a threshold \Rfunction{l} for the asymptotic standard deviation. The default value for \Rfunction{l} is 0.05 that is considered to be small enough, but other values can be chosen : the function \Rfunction{LBEa} described below illustrates the relation between \Rfunction{a} and \Rfunction{l} for a fixed number of tested hypotheses.

A particular value for \Rfunction{a} can also be directly set (without using the parameter \Rfunction{l}). Choosing values of \Rfunction{a} less that 1 leads to use the identity function for transforming the p-values, that is to say the estimator (\ref{initest}). 

First we apply the function \Rfunction{LBE} by changing the upper bound for the asymptotic standard deviation, then, we apply \Rfunction{LBE} by arbitrarily setting $a=2$ and finally, we do not transform the p-values (by setting $a=-1$).

\bigskip

<<>>=
LBE.res5 <- LBE(golub.pval,a=2,l=NA,plot.type="none")
LBE.res5$a; LBE.res5$l; LBE.res5$pi0; LBE.res5$pi0.ci; LBE.res5$n.significant
LBE.res6 <- LBE(golub.pval,a=NA,l=0.1,plot.type="none")
LBE.res6$a; LBE.res6$l; LBE.res6$pi0; LBE.res6$pi0.ci; LBE.res6$n.significant
LBE.res7 <- LBE(golub.pval,a=-1,l=NA,plot.type="none")
LBE.res7$a; LBE.res7$l; LBE.res7$pi0; LBE.res7$pi0.ci; LBE.res7$n.significant
@

\subsection{\Rfunction{LBEplot}}

If \Rfunction{plot.type="main"}, the function \Rfunction{LBEplot}, that is called by the main function \Rfunction{LBE}, displays the plot of the q-values versus the p-values together with the histogram of the p-values. The FDR and the numbers of significant and non significant genes are displayed in the legend.

If \Rfunction{plot.type="multiple"} (default value), the function LBEplot produces four plots: an histogram of the p-values, the plot of the q-values versus the p-values, the number of significant genes versus the q-values and the number of expected false positives by the number of significant genes.



\begin{center}
<<fig=true, width = 6, height = 6>>=
LBEplot(LBE.res,plot.type="multiple")
@
\end{center}
\bigskip


\subsection{\Rfunction{LBEa}}

The \Rfunction{LBEa} function is called by the main function \Rfunction{LBE} for choosing the greatest value of \Rfunction{a} such that the upper bound of the asymptotic standard deviation is less than a threshold \Rfunction{l}. A plot illustrating the relation between \Rfunction{a} and \Rfunction{l} for a fixed number of tested hypotheses is displayed.



\begin{center}
<<fig=true, width = 6, height = 6>>=
LBEa(length(golub.pval),l=0.1)
@
\end{center}
\bigskip


\subsection{\Rfunction{LBEsummary}}

The function \Rfunction{LBEsummary} is analogous to the function \Rfunction{summary} from the \Rfunction{qvalue} package. It reports an estimate and a confidence interval for the proportion of true null hypotheses and presents a table comparing p-values to q-values.

<<>>=
LBEsummary(LBE.res)
@

\subsection{\Rfunction{LBEwrite}}

The \Rfunction{LBEwrite} function is analogous to the \Rfunction{qwrite} function from the \Rfunction{qvalue} package. It writes the output of the function \Rfunction{LBE} to a file.

<<>>=
LBEwrite(LBE.res)
@

\section{Comparison with the \Rfunction{qvalue} package}


The \Rfunction{qvalue} package contains functions for the estimation and presentation of the q-values following the method introduced by Storey and Tibshirani \cite{Storey2}. While the default method for estimating $\pi _{0}$ (in the \Rfunction{qvalue} function) relies on a smoothing method for estimating the marginal density evaluated at one, LBE is based on the expectation of a transformation of the p-values.

As regards to \Rfunction{qvalue}, the results of a simulation study \cite{Dalmasso} indicates good performances for \Rfunction{LBE}. Moreover, the thoretical results we have obtained allow the calculation of a confidence interval for $\pi _{0}$.

We compare here the two methods with the dataset from Golub \it{et al.} \cite{Golub}.

<<>>=
library(qvalue)
qvalue.res <- qvalue(golub.pval)
summary(qvalue.res)
LBEsummary(LBE.res)
@


\begin{thebibliography}{9}

\bibitem{Benjamini} Benjamini Y, Hochberg Y. (1995) Controlling the false discovery rate : a practical and powerful approach to multiple testing. J R Stat Soc Ser B, 57, 289-300.

\bibitem{Dalmasso} Dalmasso, C; Broet, P.; Moreau, T. (2005) A simple procedure for estimating the false discovery rate. Bioinformatics. Bioinformatics, 21: 660 - 668.

\bibitem{Golub} Golub TR, Slonim DK, Tamayo P, Huard C, Gaasenbeek M, Mesirov JP, Coller H, Loh ML, Downing JR, Caligiuri MA, Bloomfield CD and
Lander ES (1999) Molecular Classification of Cancer: Class Discovery and Class Prediction by Gene Expression Monitoring, Science, 531-537.

\bibitem{Storey1} Storey JD. (2001) A direct approach to false discovery rates. J R Stat Soc Ser B; 64, 479-498.

\bibitem{Storey2} Storey JD, Tibshirani R. (2003b) Statistical significance for genome-wide studies. Proc Natl Acad Sci, 100, 9440-9445.

\end{thebibliography}


\end{document}

\name{hedenfalk.pval}
\alias{hedenfalk.pval}
\docType{data}
\title{ p-values corresponding to the gene expression data from Hedenfalk et al. (2001). }
\description{
  The aim of the study of Hedenfalk et al. (2001) was to examine breast-cancer tissues from patients with BRCA1-BRCA2 related cancer and cases of sporadic breast cancer to determine global gene expression patterns in the different classes of tumours. Here, we focus on the comparison of BRCA1 and BRCA2. The p-values provided here are the same as those provided with the package \code{qvalue}. They were otained from a two-sample t-test analysis on a subset of 3,170 genes, as described in Storey and Tibshirani (2003).
}
\usage{data(hedenfalk.pval)}
\format{
  The format is:
 num [1:3170] 0.0121 0.0750 0.9949 0.0418 0.8458 ...
}

\references{
  Hedenfalk I, Duggan D, Chen Y, Radmacher M, Bittner M, Simon R, Meltzer P, Guterson B, Esteller M, Kallioniemi OP et al. (2001) Gene-expression profiles in hereditary breast cancer. N Engl J Med, 22, 539-548.
  
  Storey JD and Tibshirani R. (2003). Statistical significance for genome-wide studies. Proc Natl Acad Sci, 100, 9440-9445.
}
\keyword{datasets}   

\name{golub.pval}
\alias{golub.pval}
\docType{data}
\title{ p-values corresponding to the gene expression data from Golub et al. (1999). }
\description{
  The aim of the study of Golub et al. \cite{Golub} was to identify differentially expressed genes between acute myeloid leukemia (AML) and acute lymphoblastic leukemia (ALL). 
  The samples were assayed using Affymetrix Hgu6800 chips and the data on the expression of 7129 genes are available in the Bioconductor package \code{golubEsets}.
  The p-values provided here were calculated from a two-sample t-test analysis. The variance-stabilizing method included in the \code{vsn} package was applied for normalizing the data.
}
\usage{data(golub.pval)}
\format{
  The format is:
 num [1:3051] 0.0170 0.2552 0.9130 0.7867 0.2431 ...
}
\references{
Golub TR, Slonim DK, Tamayo P, Huard C, Gaasenbeek M, Mesirov JP, Coller H, Loh ML, Downing JR, Caligiuri MA, Bloomfield CD, Lander ES (1999). Molecular classification of cancer: class discovery and class prediction by gene expression monitoring. Science, 15, 286(5439), 531-7.
}
\keyword{datasets}

\name{LBEa}
\alias{LBEa}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Optimal setting for the parameter a }
\description{
  The LBEa function is called by the main function LBE for choosing the greatest value of a such that the upper bound of the asymptotic standard deviation is less than a threshold l. A plot illustrating the relation between a and l for a fixed number of tested hypotheses can also be displayed.

}
\usage{
LBEa(m, l = 0.05, fig = TRUE, a.rng = NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{m}{ Total number of tested hypotheses. }
  \item{l}{ Threshold for the upper bound of the asymptotic standard deviation (default value is 0.05). }
  \item{fig}{ Logical value for plotting the standard deviation versus a. }
  \item{a.rng}{ Range of values of a to consider. If a.rng == NA, a.rng is set such that the standard deviation is less than 0.5. }
}
\details{
The procedure LBE is based on the expectation of a particular transformation of the p-values leading to a straightforward estimation of the key quantity pi0 that is the proportion of true null hypotheses:
  \deqn{pi0(a)={(1/m)*\sum_{i=1}^{m}[-\ln(1-pi)]^a]}/\Gamma(a+1) }
where a belongs to the interval \eqn{[1;inf)}.   
As there is a balance between bias (decreasing as a increase) and variance (increasing as a increase), for a specified number m of tested hypotheses, we have proposed to choose the greatest value of a such that the upper bound of the asymptotic standard deviation of the estimator of pi0 is smaller than the threshold l.
The function LBEa allows to plot the standard deviation versus a in order to help for the choice of the threshold l (for a specific number m of tested hypotheses). 
}
\value{
  \item{a }{ Greatest value of a such that the the upper bound of the asymptotic standard deviation of the estimator of pi0 is smaller than the threshold l. }
}
\references{ 
Dalmasso C, Broet P, Moreau T (2005). A simple procedure for estimating the false discovery rate. Bioinformatics. Bioinformatics, 21: 660 - 668. 
}
\author{ Cyril Dalmasso }

\seealso{ \code{\link{LBE}}, \code{\link{LBEplot}}, \code{\link{LBEsummary}}, \code{\link{LBEwrite}} }
\examples{
## start
data(hedenfalk.pval)
m <- length(hedenfalk.pval)
LBEa(m,l = 0.05)
## end
}
\keyword{ misc }

\name{LBEplot}
\alias{LBEplot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Graphical display of LBE objects. }
\description{
  Graphical display of LBE objects. 
}
\usage{
LBEplot(LBEobj, rng = c(0, 0.1), plot.type = c("multiple", "main"), legend = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{LBEobj}{ LBE object. }
  \item{rng}{ Range of q-values to consider.  }
  \item{plot.type}{  
  If plot.type == "main", The estimated q-values versus the p-values are
  plotted together with the histogram of the p-values.  
 
  If plot.type == "multiple" (default value), several graphics are displayed.

  }
  \item{legend}{ Logical value for displaying the legend on the plot (when
  plot.type == "main").}
 
}
\details{
  If plot.type == "multiple", the following graphics are displayed:
  1. The histogram of the p-values. 
  2. The estimated q-values versus the p-values. 
  3. The number of significant tests versus each qvalue cutoff. 
  4. The number of expected false positives versus the number of significant tests.
}
\author{ Cyril Dalmasso }
\note{ 
The function LBEplot is analogous to the function qplot from the package \code{qvalue}.
}
\seealso{ \code{\link{LBE}}, \code{\link{LBEsummary}}, \code{\link{LBEwrite}}, \code{\link{LBEa}} }
\examples{
## start
data(hedenfalk.pval)
res=LBE(hedenfalk.pval,plot.type="none")
LBEplot(res)
LBEplot(res,plot.type="main")
LBEplot(res,plot.type="main",legend=FALSE)
## end
}
\keyword{ htest }

\name{LBEwrite}
\alias{LBEwrite}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Write the results of an LBE object to a file. }
\description{
  Write the results of an LBE object to a file.
}
\usage{
LBEwrite(LBEobj, filename = "LBE-results.txt")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{LBEobj}{ LBE object }
  \item{filename}{ Output filename (optional) }
}
\details{
  The output file lists the estimate of pi0, which is the proportion of true null hypotheses. It also lists each p-value and corresponding q-value, one per line. If an FDR significance level was specified in the call to qvalue, the significance level is printed below the estimate of pi0, and an indicator of significance is included as a third column for each p-value and q-value.  
}

\author{ Cyril Dalmasso }
\note{ 
  The function LBEwrite is analogous to the function qwrite from the package
  \code{qvalue}.
 
}
\seealso{ \code{\link{LBE}}, \code{\link{LBEplot}}, \code{\link{LBEsummary}}, \code{\link{LBEa}} }
\examples{
## start
data(hedenfalk.pval)
res<-LBE(hedenfalk.pval)
LBEwrite(res,filename="myresults.txt")
## end
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ htest }

\name{LBE-package}
\alias{LBE-package}
\docType{package}
\title{
Estimation of the proportion of true null hypotheses, the false discovery rate and the q-values.
}
\description{
The package LBE allows estimating the proportion of true null hypotheses and the false discovery rate. 
}
 

\details{
\tabular{ll}{
Package: \tab LBE\cr
Type: \tab Package\cr
Version: \tab 1.13.2\cr
Date: \tab 2007-1-10\cr
License: \tab GPL-2\cr
}
}
\author{
Cyril Dalmasso
Maintainer: Cyril Dalmasso \email{dalmasso@vjf.inserm.fr}
}
\references{
Dalmasso C, Broet P, Moreau T (2005): A simple procedure for estimating the false discovery rate. Bioinformatics, 21: 660 - 668.

Storey JD and Tibshirani R. (2003). Statistical significance for genome-wide studies. Proc Natl Acad Sci, 100, 9440-9445.
}
\seealso{
LBE is an alternative method to the one proposed by Storey and Tibshirani (2003) for estimating the q-values, this latter method being implemented in the package \code{\link[qvalue]{qvalue}}.
}
\keyword{ package }

\name{LBE}
\alias{LBE}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Estimation of the false discovery rate. }
\description{
LBE is an efficient procedure for estimating the proportion of true null hypotheses, the false discovery rate and the q-values.  
}
\usage{
LBE(pval, a = NA, l = 0.05, ci.level = 0.95, qvalues = TRUE, plot.type = "main", FDR.level = 0.05, n.significant = NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pval}{ Numerical vector of p-values (only necessary input). }
  \item{a}{ Real value used in \eqn{[-ln (1-pi)]^a}  (see details).
  If a == NA (default), then the value of a is automatically calculated as the greatest value such that the upper bound of the asymptotic standard deviation of the estimator of pi0 is smaller than the threshold l. 
  If \eqn{a >= 1}, the value of a is used in \eqn{[-ln (1-pi)]^a} (see
  details).
 
  If \eqn{a < 1}, the identity function is used for transforming the
  p-values. }
 
  \item{l}{ Threshold for the upper bound of the asymptotic standard deviation
  (only used if a == NA). }
  \item{ci.level}{ Level for the confidence interval of pi0.  }
  \item{qvalues}{ Logical value for estimating the qvalues and the FDR. If
    qvalues = FALSE, only the proportion pi0 of true null hypotheses is
    estimated. }
 
  \item{plot.type}{ 
  If plot.type = "none", no graphic is displayed.
  If plot.type = "main", the estimated q-values versus the p-values are
  plotted together with the histogram of the p-values.  
 
  If plot.type = "multiple", several graphics are displayed: 1. The histogram
  of the p-values 2. The estimated q-values versus the p-values 3. The number
  of significant tests versus each qvalue cutoff 4. The number of expected
  false positives versus the number of significant tests.  }
 
  \item{FDR.level}{ Level at which to control the FDR (only used if
  n.significant == NA). }
  \item{n.significant}{ If specified, the FDR is estimated for the rejection
  region defined by the "n.significant" smallest p-values. }
 
}
\details{
  The procedure LBE is based on the expectation of a particular transformation
  of the p-values leading to a straightforward estimation of the key quantity
  pi0 that is the proportion of true null hypotheses:
 
  \eqn{pi0(a)=\{(1/m)*\sum_{i=1}^m[-\ln(1-pi)]^a\}/\Gamma(a+1),}
where a belongs to the interval \eqn{[1;inf)}.    
}
\value{
  A list containing:
  \item{ call }{Function call.}
  \item{ FDR }{Level at which to control the FDR (if n.significant == NA) or
    estimated FDR (if n.significant != NA).}
  \item{ pi0 }{Estimated value of pi0, the proportion of true null
    hypotheses.}
 
  \item{ pi0.ci }{Confidence interval for pi0.}
  \item{ ci.level }{Level for the confidence interval of pi0.}
  \item{ a }{Value used in \eqn{[-\ln (1-pi)]^a} (see details).}
  \item{ l }{Upper bound of the asymptotic standard deviation for pi0.}
  \item{ qvalues }{Vector of the estimated q-values.}
  \item{ pvalues }{Vector of the original p-values.}
  \item{ significant }{Indicator of wether the null hypothesis is rejected.}
  \item{ n.significant }{Number of rejected null hypotheses.}
}
\references{ 
Dalmasso C, Broet P, Moreau T (2005). A simple procedure for estimating the
false discovery rate. Bioinformatics. Bioinformatics, 21: 660 - 668. 
 

Storey JD and Tibshirani R. (2003). Statistical significance for genome-wide
studies. Proc Natl Acad Sci, 100, 9440-9445.
 
}
\author{ Cyril Dalmasso }
\note{ 
LBE is an alternative method to the one proposed by Storey and Tibshirani
(2003) for estimating the q-values, this latter method being implemented in
the package \code{qvalue}.
 
}
\seealso{ \code{\link{LBEplot}}, \code{\link{LBEsummary}}, \code{\link{LBEwrite}}, \code{\link{LBEa}} }
\examples{
## start
data(hedenfalk.pval)
res=LBE(hedenfalk.pval)
data(golub.pval)
res=LBE(golub.pval)
## end
}
\keyword{ htest }

\name{LBEsummary}
\alias{LBEsummary}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Display LBE object }
\description{
  Display summary information for an LBE object.
}
\usage{
LBEsummary(LBEobj, cuts = c(1e-04, 0.001, 0.01, 0.025, 0.05, 0.1, 1), digits = getOption("digits"), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{LBEobj}{ LBE object. }
  \item{cuts}{ Vector of significance value to use for table. }
  \item{digits}{ Significant digits to display. }
  \item{\dots}{ Any other arguments. }
}
\details{
  LBEsumary shows the original call, estimated proportion of true null hypotheses, confidence interval for the proportion of true null hypotheses and a table comparing the number of significant calls for the p-values and for the estimated q-values using a set of cutoffs given by the argument cuts.
}
\value{
Invisibly returns the original object.
}
\author{ Cyril Dalmasso }
\note{ 
  The function LBEsummary is analogous to the function qsummary from the
  package \code{qvalue}.
}
\seealso{ \code{\link{LBE}}, \code{\link{LBEplot}}, \code{\link{LBEwrite}}, \code{\link{LBEa}} }
\examples{
## start
data(hedenfalk.pval)
res<-LBE(hedenfalk.pval)
print(res)
LBEsummary(res)
## end
}

\keyword{ htest }
